create table user_worktimes
(
   id int auto_increment,
   user_id int,
   day_of_week int,
   hours_per_day int,
   constraint pk_user_worktimes primary key (id),
   constraint fk_user_worktimes_users foreign key (user_id) references users (id) on update cascade on delete cascade
);

create unique index idx_user_worktimes_day_of_week on user_worktimes (user_id, day_of_week);

delimiter //
create procedure update_user_worktimes ()
begin
	-- Monday
	insert into user_worktimes (user_id, day_of_week, hours_per_day) select u.id, 1 as day_of_week, 6 as hours_per_day from users u where not exists (select w.* from user_worktimes w where w.user_id=u.id and day_of_week=1);
	-- Tuesday
	insert into user_worktimes (user_id, day_of_week, hours_per_day) select u.id, 2 as day_of_week, 6 as hours_per_day from users u where not exists (select w.* from user_worktimes w where w.user_id=u.id and day_of_week=2);
	-- Wednesday
	insert into user_worktimes (user_id, day_of_week, hours_per_day) select u.id, 3 as day_of_week, 6 as hours_per_day from users u where not exists (select w.* from user_worktimes w where w.user_id=u.id and day_of_week=3);
	-- Thursday
	insert into user_worktimes (user_id, day_of_week, hours_per_day) select u.id, 4 as day_of_week, 6 as hours_per_day from users u where not exists (select w.* from user_worktimes w where w.user_id=u.id and day_of_week=4);
	-- Friday
	insert into user_worktimes (user_id, day_of_week, hours_per_day) select u.id, 5 as day_of_week, 6 as hours_per_day from users u where not exists (select w.* from user_worktimes w where w.user_id=u.id and day_of_week=5);
	-- Saturday
	insert into user_worktimes (user_id, day_of_week, hours_per_day) select u.id, 6 as day_of_week, 0 as hours_per_day from users u where not exists (select w.* from user_worktimes w where w.user_id=u.id and day_of_week=6);
	-- Sunday
	insert into user_worktimes (user_id, day_of_week, hours_per_day) select u.id, 7 as day_of_week, 0 as hours_per_day from users u where not exists (select w.* from user_worktimes w where w.user_id=u.id and day_of_week=7);
end//

create trigger users_update_worktimes after insert on users 
	for each row
		call update_user_worktimes();
//

delimiter ;

call update_user_worktimes;

create table debug
(
   text varchar(1024)
);

